<?php

namespace App\Console;

use App\Console\Commands\WaybillCreate;
use App\Console\Commands\SyncUserWithServer;
use App\Console\Commands\WaybillCreate4s;
use App\Console\Commands\WaybillCreateCron;
use App\Console\Commands\WaybillCreateesm3;
use App\Console\Commands\WaybillCreateesm4;
use App\Console\Commands\WaybillCreateesm7;
use App\Console\Commands\WaybillCreateEsmCron;
use App\Console\Commands\WaybillCreatef1;
use Illuminate\Console\Scheduling\Schedule;
use Illuminate\Foundation\Console\Kernel as ConsoleKernel;

class Kernel extends ConsoleKernel
{
    /**
     * The Artisan commands provided by your application.
     *
     * @var array
     */
    protected $commands = [
        SyncUserWithServer::class,
        WaybillCreate::class,
        WaybillCreate4s::class,
        WaybillCreatef1::class,
        WaybillCreateesm3::class,
        WaybillCreateesm4::class,
        WaybillCreateesm7::class,
        WaybillCreateCron::class,
        WaybillCreateEsmCron::class,
    ];

    /**
     * Define the application's command schedule.
     *
     * @param  \Illuminate\Console\Scheduling\Schedule  $schedule
     * @return void
     */
    protected function schedule(Schedule $schedule)
    {
         $schedule->command(SyncUserWithServer::class)
                  ->everyMinute();

         $schedule->command(WaybillCreateCron::class)->daily('8:00');
         $schedule->command(WaybillCreateEsmCron::class)->cron('00 08 */10 * *');
    }

    /**
     * Register the Closure based commands for the application.
     *
     * @return void
     */
    protected function commands()
    {
        require base_path('routes/console.php');
    }
}
