<?php

namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Contracts\Queue\ShouldQueue;

class CronsReport extends Mailable
{
    use Queueable, SerializesModels;

    /**
     * The order instance.
     *
     * @var array
     */
    protected $files;

    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct($files = [])
    {
        $this->files = $files;
    }

    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {
        $mail = $this->view('crons.emails.report');

        if (count($this->files) > 0) {
            foreach ($this->files as $file) {
                $mail = $mail->attach(resource_path($file));
            }
        }

        return $mail;
    }
}
