<?php

use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateSyncTable extends Migration
{
    /**
     * Schema table name to migrate
     * @var string
     */
    public $set_schema_table = 'sync';

    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create($this->set_schema_table, function (Blueprint $table)
        {
            $table->engine = 'InnoDB';
            $table->increments('id');
            $table->enum('type', ['new', 'update'])->default('new');
            $table->unsignedInteger('users_id')->nullable();

            $table->index(['users_id'], 'fk_sync_users1_idx');
            $table->nullableTimestamps();

            $table->foreign('users_id', 'fk_sync_users1_idx')
                ->references('id')->on('users')
                ->onDelete('no action')
                ->onUpdate('no action');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists($this->set_schema_table);
    }
}
