<?php

use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class AddColumnsWaybillsTable extends Migration
{
    /**
     * Schema table name to migrate
     * @var string
     */
    public $set_schema_table = 'waybills';

    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table($this->set_schema_table, function (Blueprint $table)
        {
            $table->string('customer')->nullable();
            $table->string('place_work')->nullable();
            $table->string('type_work')->nullable();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        if (Schema::hasColumns($this->set_schema_table, ['customer', 'place_work', 'type_work'])) {
            Schema::table($this->set_schema_table, function (Blueprint $table)
            {
                $table->dropColumn('customer');
                $table->dropColumn('place_work');
                $table->dropColumn('type_work');
            });
        }
    }
}
