# Web Installer
Возможности установщика :

	- проверяет требования к серверу.
	- проверяет права доступа к директориям.
	- установка миграций и seed данных базы данных.

## Установка

Сначала добавить пакет в Composer.

```
"require": {
    "monitorit/installer": "1.0"
}
```

Затем выполнить :

```
composer update
```

После добавить service provider в файле `config/app.php`.

```
'providers' => [
    Monitorit\Installer\Providers\InstallerServiceProvider::class,
];
```

## Использование

Выполнить перед использованием компонента :
```bash
php artisan vendor:publish --provider="Monitorit\Installer\Providers\InstallerServiceProvider"
```

Это добавит в проект файлы:

 - `config/installer.php` : файл с конфигурациями установщика.
 - `public/installer/assets` : директория с css, js, images файлами установщика.
 - `resources/views/vendor/installer` : директория шаблонов установщика.
 - `resources/lang/ru/installer_messages.php` : файл локализации установщика, если надо на другой язык перевести, создать папку языка, скопировать файл и перевести.

## Установка и обновление приложения

Для установки приложения, перейдите `/install` и следуйте инструкциям.

Для обновления приложения, перейдите `/update` и следуйте инструкциям.

## Screenshots

![Web installer](http://i.imgur.com/3vYBPLn.png)