<?php

namespace Monitorit\Installer\Middleware;

use Closure;
use Illuminate\Support\Facades\File;

class RedirectInstall
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request $request
     * @param  \Closure $next
     *
     * @return mixed
     */
    public function handle($request, Closure $next)
    {
        if ($request->is('install') || $request->is('install/*')) {
            return $next($request);
        }

        if ($this->alreadyInstalled()) {
            return $next($request);
        }

        return redirect('/install');
    }

    /**
     * If application is already installed.
     *
     * @return bool
     */
    public function alreadyInstalled()
    {
        return File::exists(storage_path('installed'));
    }
}
