<!-- Users Id Field -->
<div class="form-group">
    <div class="col-sm-10">
        {!! Form::hidden('users_id', \Auth::user()->id, ['class' => 'form-control']) !!}
    </div>
</div>

<!-- Type Field -->
<div class="form-group">
    {!! Form::label('type', 'Тип документа:', ['class' => 'col-sm-2']) !!}
    <div class="col-sm-10">
        {!! Form::select('type', getTypesWaybill(), null, ['class' => 'form-control', 'onchange' => 'show_fields();']) !!}
    </div>
</div>

<!-- Email Field -->
<div class="form-group">
    {!! Form::label('email', 'Email доставки документов:', ['class' => 'col-sm-2']) !!}
    <div class="col-sm-10">
        {!! Form::text('email', null, ['class' => 'form-control']) !!}
    </div>
</div>

<!-- Active Field -->
<div class="form-group">
    {!! Form::label('active', 'Включить задание:', ['class' => 'col-sm-2']) !!}
    <div class="col-sm-10">
        <div class="checkbox">
            <label>
                {!! Form::checkbox('active') !!} Для включения задания установите галочку
            </label>
        </div>
    </div>
</div>

@include('waybills.fields2')

<div class="panel panel-default">
    <div class="panel-heading">Выберите объекты входящие в задания</div>
    <div class="panel-body">
        @forelse(getObjects(\Auth::user()->id, false) as $id => $name)
            <div class="col-xs-2">
                <div class="checkbox">
                    <label>
                        {!! Form::checkbox('objects[]', $id) !!} {{ $name }}
                    </label>
                </div>
            </div>
        @empty
            <p>У вас не найдено объектов, создание автоматического задания не возможно</p>
        @endforelse
    </div>
</div>

<!-- Submit Field -->
<div class="form-group text-center">
    {!! Form::submit('Сохранить', ['class' => 'btn btn-primary']) !!}
    <a href="{!! route('crons.index') !!}" class="btn btn-default">Назад</a>
</div>
