@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row">
        <div class="col-md-12">
            <div class="panel panel-default">
                <div class="panel-heading">Приветствие</div>

                <div class="panel-body">
                    <ol>
                        <li><a href="{{ url('/') }}" data-toggle="tooltip" data-placement="top" title="Обновить страницу">Дождаться синхронизацию</a>. Синхронизация обычно длится не более минуты, переодически обновляйте страницу, если сообщение сверху исчезло, можно идти дальше по списку.</li>
                        <li><a href="{{ route('owners.create') }}" data-toggle="tooltip" data-placement="top" title="Перейти к добавлению">Добавить владельца(ев)</a>. Добавьте владельца(ев) транспотрных средств, чтобы при генерации путевого листа вы могли выбрать нужного владельца для подстановки его в путевой лист. Так же хотим сказать, что этот шаг необязательный вы можете добавить на сервере у объекта произвольное поле "<strong>Организация</strong>" при генерации скрипт сам возьмет его значение для подстановки в путевой лист.</li>
                        <li><a href="{{ route('drivers.create') }}" data-toggle="tooltip" data-placement="top" title="Перейти к добавлению">Добавить водителя(ей)</a>. Добавьте водителя(ей) транспотрных средств, чтобы при генерации путевого листа вы могли выбрать нужного водителя для подстановки его в путевой лист. Так же хотим сказать, что этот шаг необязательный вы можете назначить водителя к объекту на сервере и наш скрипт сам подставит необходимые данные в путевой лист. Табельный номер, укажите в поле "<strong>Код</strong>".</li>
                        <li><a href="{{ route('objects.index') }}" data-toggle="tooltip" data-placement="top" title="Перейти к списку">Отредактируйте объект(ы)</a>. Шаг необязательный и тем более не требуется делать это каждыйц раз, один раз настроили и все. К сожалению вам придется в ручную настроить несколько параметров объекта, а именно:
                        <ul>
                            <li>Тип обекта - выберите один из доступных</li>
                            <li>Модель объекта - укажите модель(марку) объекта</li>
                            <li>Гос. номер - укажите государственный номер объекта</li>
                            <li>Марка топлива - укажите марку топлива объекта</li>
                            <li>Гаражный номер - укажите Гаражный номер объекта</li>
                        </ul>Так же хотелось бы упомянуть, вы можете добавить произвольные поля (Марка автомобиля, Государственный номерной знак, Марка горючего, Гаражный номер) к объекту на сервере и необходимость редактировать объекты у нас на сайте отпадет.
                        </li>
                        <li>Можно переходить к <a href="{{ route('waybills.create') }}" data-toggle="tooltip" data-placement="top" title="Перейти к генерации">генерации</a> путевого листа</li>
                    </ol>

                    <p class="text-primary"><i>PS: не забывайте, имена произвольным полям нужно дать в строгом соответствии с указанными в инструкции выше.</i></p>
                </div>
            </div>
        </div>

        <div class="col-md-12">
            <div class="panel panel-info">
                <div class="panel-heading">Генерация</div>
                <div class="panel-body">
                    <div class="col-md-3">
                        <a href="{{ route('waybills.create', ['type' => 'f1']) }}" class="btn btn-block btn-primary">Путевой лист: Форма №1</a>
                    </div>
                    <div class="col-md-3">
                        <a href="{{ route('waybills.create') }}" class="btn btn-block btn-primary">Путевой лист: Форма №4С</a>
                    </div>
                    <div class="col-md-2">
                        <a href="{{ route('waybills.create', ['type' => 'esm3']) }}" class="btn btn-block btn-primary">ЭСМ - 3</a>
                    </div>
                    <div class="col-md-2">
                        <a href="{{ route('waybills.create', ['type' => 'esm4']) }}" class="btn btn-block btn-primary">ЭСМ - 4</a>
                    </div>
                    <div class="col-md-2">
                        <a href="{{ route('waybills.create', ['type' => 'esm7']) }}" class="btn btn-block btn-primary">ЭСМ - 7</a>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection
