<?php

use Illuminate\Foundation\Testing\WithoutMiddleware;
use Illuminate\Foundation\Testing\DatabaseTransactions;

class ServersApiTest extends TestCase
{
    use MakeServersTrait, ApiTestTrait, WithoutMiddleware, DatabaseTransactions;

    /**
     * @test
     */
    public function testCreateServers()
    {
        $servers = $this->fakeServersData();
        $this->json('POST', '/api/v1/servers', $servers);

        $this->assertApiResponse($servers);
    }

    /**
     * @test
     */
    public function testReadServers()
    {
        $servers = $this->makeServers();
        $this->json('GET', '/api/v1/servers/'.$servers->id);

        $this->assertApiResponse($servers->toArray());
    }

    /**
     * @test
     */
    public function testUpdateServers()
    {
        $servers = $this->makeServers();
        $editedServers = $this->fakeServersData();

        $this->json('PUT', '/api/v1/servers/'.$servers->id, $editedServers);

        $this->assertApiResponse($editedServers);
    }

    /**
     * @test
     */
    public function testDeleteServers()
    {
        $servers = $this->makeServers();
        $this->json('DELETE', '/api/v1/servers/'.$servers->id);

        $this->assertApiSuccess();
        $this->json('GET', '/api/v1/servers/'.$servers->id);

        $this->assertResponseStatus(404);
    }
}
