<?php

use Faker\Factory as Faker;
use App\Models\Drivers;
use App\Repositories\DriversRepository;

trait MakeDriversTrait
{
    /**
     * Create fake instance of Drivers and save it in database
     *
     * @param array $driversFields
     * @return Drivers
     */
    public function makeDrivers($driversFields = [])
    {
        /** @var DriversRepository $driversRepo */
        $driversRepo = App::make(DriversRepository::class);
        $theme = $this->fakeDriversData($driversFields);
        return $driversRepo->create($theme);
    }

    /**
     * Get fake instance of Drivers
     *
     * @param array $driversFields
     * @return Drivers
     */
    public function fakeDrivers($driversFields = [])
    {
        return new Drivers($this->fakeDriversData($driversFields));
    }

    /**
     * Get fake data of Drivers
     *
     * @param array $postFields
     * @return array
     */
    public function fakeDriversData($driversFields = [])
    {
        $fake = Faker::create();

        return array_merge([
            'surname' => $fake->word,
            'name' => $fake->word,
            'middlename' => $fake->word,
            'users_id' => $fake->randomDigitNotNull,
            'created_at' => $fake->date('Y-m-d H:i:s'),
            'updated_at' => $fake->date('Y-m-d H:i:s')
        ], $driversFields);
    }
}
