<?php

use Faker\Factory as Faker;
use App\Models\Owners;
use App\Repositories\OwnersRepository;

trait MakeOwnersTrait
{
    /**
     * Create fake instance of Owners and save it in database
     *
     * @param array $ownersFields
     * @return Owners
     */
    public function makeOwners($ownersFields = [])
    {
        /** @var OwnersRepository $ownersRepo */
        $ownersRepo = App::make(OwnersRepository::class);
        $theme = $this->fakeOwnersData($ownersFields);
        return $ownersRepo->create($theme);
    }

    /**
     * Get fake instance of Owners
     *
     * @param array $ownersFields
     * @return Owners
     */
    public function fakeOwners($ownersFields = [])
    {
        return new Owners($this->fakeOwnersData($ownersFields));
    }

    /**
     * Get fake data of Owners
     *
     * @param array $postFields
     * @return array
     */
    public function fakeOwnersData($ownersFields = [])
    {
        $fake = Faker::create();

        return array_merge([
            'type' => $fake->word,
            'company' => $fake->text,
            'surname' => $fake->word,
            'name' => $fake->word,
            'middlename' => $fake->word,
            'address' => $fake->word,
            'phone' => $fake->word,
            'users_id' => $fake->randomDigitNotNull,
            'created_at' => $fake->date('Y-m-d H:i:s'),
            'updated_at' => $fake->date('Y-m-d H:i:s')
        ], $ownersFields);
    }
}
