<?php

use Faker\Factory as Faker;
use App\Models\Servers;
use App\Repositories\ServersRepository;

trait MakeServersTrait
{
    /**
     * Create fake instance of Servers and save it in database
     *
     * @param array $serversFields
     * @return Servers
     */
    public function makeServers($serversFields = [])
    {
        /** @var ServersRepository $serversRepo */
        $serversRepo = App::make(ServersRepository::class);
        $theme = $this->fakeServersData($serversFields);
        return $serversRepo->create($theme);
    }

    /**
     * Get fake instance of Servers
     *
     * @param array $serversFields
     * @return Servers
     */
    public function fakeServers($serversFields = [])
    {
        return new Servers($this->fakeServersData($serversFields));
    }

    /**
     * Get fake data of Servers
     *
     * @param array $postFields
     * @return array
     */
    public function fakeServersData($serversFields = [])
    {
        $fake = Faker::create();

        return array_merge([
            'url' => $fake->text,
            'name' => $fake->text,
            'created_at' => $fake->date('Y-m-d H:i:s'),
            'updated_at' => $fake->date('Y-m-d H:i:s')
        ], $serversFields);
    }
}
